
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine PLECTUR (fichi, irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       use auxiliaries
       USE RF_TOOLS
       USE H2_DATA
       USE SP_DATA
       USE STR_DATA
       USE CHEM_DATA
       USE PROFIL

        implicit double precision (a-h,o-z)

c  definition des variables locales.
c  (les variables transmises sont dans INCLUDE).

        character (LEN=75) :: texte
        character (LEN=50) :: fichi
        character (LEN=50) :: fichout
        character (LEN=8)  :: yspec

        integer       itm1, itm2, itm3

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c   Lecture des resultats du run a analyser:

       print *
       print *,'----------------------------------------'
       print *,'Lecture de ',fichi
       print *,'----------------------------------------'

       fichier = TRIM(out_dir)//fichi
       open (26, file = fichier, status = 'old'
     1          , form = 'unformatted')

       read (26) npo, nspec, cdunit, rrr, l0h2, mjh2
     1         , l0hd, mjhd
       read (26)
     1           i_h, i_d, i_hgr, i_dgr, i_h2, i_hd, i_h2gr, i_he,
     1           i_c, i_n, i_o, i_s, i_si, 
     1           i_cp, i_np, i_op, i_sp, i_sip, 
     1           i_h2o, i_oh, i_co0, i_co1, i_co2, i_co3,
     2           i_hp, i_h2dp, i_h3p, i_fep,
     3           i_c2, i_cs, i_c13, i_o18, i_hcop
       read (26) speci
       read (26) npg
       allocate (surfgr(npg),tdust(npg,0:noptm), zmoy(npg,0:noptm))
       allocate (adust(npg), wwmg(npg))
       read (26) ((zmoy(i,j), i=1,npg), j=0,npo)
       read (26) (adust(i), i=1,npg)
       read (26) (wwmg(i), i=1,npg)
       read (26) (surfgr(i), i=1,npg)
       read (26) (tau(i), densh(i), tgaz(i)
     1         , (tdust(j,i),j=1,npg), i=0,npo)
       read (26) (rfjh2t(i), rfjhdt(i), refco0(i), refco1(i)
     1    , refco2(i), refcs0(i), refhcop(i), i=0,npo)
       read (26) (refcat(i), refnat(i), refoat(i), refsat(i)
     1         , refsiat(i), i=0,npo)
       read (26) (refcpl(i), refnpl(i), refopl(i), refspl(i)
     1         , refsip(i), i=0,npo)
       read (26) (refh2o(i), refoh(i), reffep(i), i=0,npo)
       read (26) (chophg(i), choh2g(i), chohdg(i)
     1         , chopht(i), chorc(i), chophs(i), i=0,npo)
       read (26) (choeqg(i), chochi(i), chotur(i), reftot(i)
     1          , chotot(i), i=0,npo)
       read (26) (emicat(:,i), i=0,npo)
       read (26) (eminat(:,i), i=0,npo)
       read (26) (emioat(:,i), i=0,npo)
       read (26) (emisat(:,i), i=0,npo)
       read (26) (emisiat(:,i), i=0,npo)
       read (26) (emicpl(:,i), i=0,npo)
       read (26) (eminpl(:,i), i=0,npo)
       read (26) (emiopl(:,i), i=0,npo)
       read (26) (emispl(:,i), i=0,npo)
       read (26) (emisip(:,i), i=0,npo)
       read (26) ((emico0(j,i), j=1,njco), i=0,npo)
       read (26) ((emico1(j,i), j=1,njco), i=0,npo)
       read (26) ((emico2(j,i), j=1,njco), i=0,npo)
       read (26) ((emico3(j,i), j=1,njco), i=0,npo)
       read (26) ((emics0(j,i), j=1,njcs), i=0,npo)
       read (26) ((emihcop(j,i), j=1,njhcop), i=0,npo)
       read (26) (timh21(i), timh22(i), timh23(i)
     1          , timh24(i), (t_25(j,i), j=1,npmg), i=0,npo)
       if (i_hd .ne. 0) then
         read (26) (timhd1(i), timhd2(i)
     1           , timhd3(i), timhd4(i), i=0,npo)
       endif
       read (26) (timco1(i), timco2(i), timco3(i), i=0,npo)
       read (26) (fluph(i), int_rad(i), i=0,npo)
       read (26) (pdish2(i), pdishd(i)
     1         , pdico0(i), pdico1(i), i=0,npo)
       read (26) (pdico2(i), pdico3(i), pdicat(i)
     1         , pdisat(i), i=0,npo)

       read (26) ((abnua(j,i), j=0,nspec), i=0,npo)
       read (26) ((xreh2(j,i), j=1,l0h2), i=0,npo)
       if (i_hd .ne. 0) then
         read (26) ((xrehd(j,i), j=1,l0hd), i=0,npo)
       endif
c       print *, l0h2, npo
c       print *

       read (26) ((xreco0(j,i), j=1,nlvco0), i=0,npo)
       read (26) ((opdco0(j,i), j=1,ntrco0), i=0,npo)
       read (26) ((xrecs0(j,i), j=1,nlvcs0), i=0,npo)
       read (26) ((opdcs0(j,i), j=1,ntrcs0), i=0,npo)
       read (26) ((xrehcop(j,i), j=1,nlvhcop), i=0,npo)
       read (26) ((opdhcop(j,i), j=1,ntrhcop), i=0,npo)
       read (26) ((xreco1(j,i), j=1,nlvco1), i=0,npo)
       read (26) ((opdco1(j,i), j=1,ntrco1), i=0,npo)
       read (26) ((xreco2(j,i), j=1,nlvco2), i=0,npo)
       read (26) ((opdco2(j,i), j=1,ntrco2), i=0,npo)
       read (26) ((xreco3(j,i), j=1,nlvco3), i=0,npo)
       read (26) ((opdco3(j,i), j=1,ntrco3), i=0,npo)
       read (26) (xrecat(:,i), i=0,npo)
       read (26) (opdcat(:,i), i=0,npo)
       read (26) (xrenat(:,i), i=0,npo)
       read (26) (opdnat(:,i), i=0,npo)
       read (26) (xreoat(:,i), i=0,npo)
       read (26) (opdoat(:,i), i=0,npo)
       read (26) (xresat(:,i), i=0,npo)
       read (26) (opdsat(:,i), i=0,npo)
       read (26) (xresiat(:,i), i=0,npo)
       read (26) (opdsiat(:,i), i=0,npo)
       read (26) (xrecpl(:,i), i=0,npo)
       read (26) (opdcpl(:,i), i=0,npo)
       read (26) (xrenpl(:,i), i=0,npo)
       read (26) (opdnpl(:,i), i=0,npo)
       read (26) (xreopl(:,i), i=0,npo)
       read (26) (opdopl(:,i), i=0,npo)
       read (26) (xrespl(:,i), i=0,npo)
       read (26) (opdspl(:,i), i=0,npo)
       read (26) (xresip(:,i), i=0,npo)
       read (26) (opdsip(:,i), i=0,npo)

       read (26) vturb
       read (26) neqt, radm, radp, itrh2, itrhd, itrco0
       read (26) itrco1, itrco2, itrco3
       read (26) ((rxigr(i,j), i=0,nspec), j=0,npo)
       read (26) ((ikmat(j,i), i=0,neqt), j=0,nspec)
       read (26) ((react(j,i), i=0,7), j=1,neqt)
       read (26) (gamm(i), i=1,neqt)
       read (26) (alpha(i), i=1,neqt)
       read (26) (bet(i), i=1,neqt)
       read (26) (de(i), i=1,neqt)
       read (26) (itype(i), i=1,neqt)
       read (26) nh2for, ncrion, npsion, nasrad, nrest
       read (26) nh2endo, nphot_f, nphot_i, n3body, ncpart, ngsurf, ngphot
       read (26) ngads, ngneut, nggdes, ncrdes, nphdes, ngevap
       read (26) nn, ni, nim, nng

       read (26) gratio, rhogr, alpgr, rgrmin, rgrmax, zeta
       read (26) vmaxw , fphsec, signgr, bsitgr, sngclb, rdeso
       read (26) dsite, (tm1h(i), i=1,nspec)
       read (26) istic, (mol(i), i=1,np)
       read (26) iadhgr, ifh2gr, idh2ph, iaddgr, ifhdgr, idhdph
     1         , idco0p, idco1p, idco2p, idco3p, idcph

c lectures des abondances relat. des bandes B et C
c et des coeff de Fitzpatrick
       read (26) (((h2bnua(iv,ij,iopt), iv=0,nvbc), ij=0,njbc)
     1           , iopt=0,npo)
       read (26) (((h2cnua(iv,ij,iopt), iv=0,nvbc), ij=0,njbc)
     1           , iopt=0,npo)
       read (26) cc1, cc2, cc3, cc4, xgam, y0, rrr

       close (26)

       tautav = 2.5_DP * log10(exp(1.0_DP))

       print *, '    Les donnees sont maintenant en memoire.'
       print *, "    Nombre de points dans la grille: ", npo
       print *, "    Nombre d'especes chimiques: ",nspec

c   Fin de lecture

       return
       end
