
c Copyright (C) 2002 - Observatoire de Paris/Meudon
c                      Universite Paris 7
c                      CNRS (France)
c                      Contact : Jacques.Lebourlot@obspm.fr
c 
c This program is free software; you can redistribute it and/or
c modify it under the terms of the GNU General Public License version 2
c as published by the Free Software Foundation.
c 
c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with this program; if not, write to the Free Software
c Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


c      %%%%%%%%%%%%%%%%%%%%%%%%
       subroutine SPECTRE(irec)
c      %%%%%%%%%%%%%%%%%%%%%%%%

       use constantes
       use prepvar
       use inoutput
       USE H2_DATA
       USE PROFIL

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c                     ordres non executables:
c                     ***********************

        implicit double precision (a-h,o-z)

        integer iask(0:noptm), idsph2(2,5000)
        real (KIND=DP) spech2(0:10,5000)
        integer iswap(5000)
        character (LEN=50) :: fichi

c--------+---------+---------+---------+---------+---------+---------+-*-------+

c  Determination du spectre de H2:
c  ------------

       npt = 0

 1002  print *, '  Quelle(s) profondeur(s) optique(s) voulez-vous?'
       print *, '      tau, fin: -1'
       read *, tauask
       if (irec .eq. 1) then
         write (8,*) tauask
       endif

       if (tauask .eq. -1) then

         goto 1001

       else

         do iopt=1,npo
           if (tau(iopt) .gt. tauask) then
             npt = npt + 1
             iask(npt) = iopt - 1
             exit
           endif
           if (iopt .eq. npo) then
             npt = npt + 1
             iask(npt) = npo
             print *, "Warning ! Last possible point"
           endif
         end do
         print *, " npt = ", npt, " tau = ", tau(iask(npt))

         goto 1002

       endif

 1001  continue

       nsp = 0

       do levu=3,l0h2
         ju = njlev(levu)
         if (ju > njh2) cycle
         do levl=1,levu-1
           jl = njlev(levl)
           if (jl > njh2 .or.
     1          (jl == 0 .and. ju == 0)) cycle
           jj = ju - jl
           if (jj == 0 .or. iabs(jj) == 2) then
             jj = jj / 2
             nvl = nvlev(levl)
             nsp = nsp +1

c  xambda en micrometre, elhm en Kelvin
             xambda = 1.0d4 * hcsurk / (elhm(levu) - elhm(levl))
             spech2(0,nsp) = xambda
             idsph2(1,nsp) = levu
             idsph2(2,nsp) = levl

             do i=1,npt
               spech2(i,nsp) = rfjh2i(levu,jj,nvl,iask(i))
             end do
           endif

         end do
       end do

c  classement par lambda croissant

       do i=1,nsp
         iswap(i) = i
       end do
       do i=1,nsp-1
         do j=i+1,nsp
           if (spech2(0,iswap(j)) .lt. spech2(0,iswap(i))) then
             k = iswap(i)
             iswap(i) = iswap(j)
             iswap(j) = k
           end if
         end do
       end do

       print *, '  entrer le nom du fichier spectre:'
       print *, '        (24 lettres maxi)' 
       read (*,3001) fichi
       fichi = TRIM(ADJUSTL(fichi))
       if (irec .eq. 1) then
         write (8,3001) fichi
 3001    format (a25)
       endif

       fichier = TRIM(out_dir)//fichi
       open (13, file = fichier, status='new')

       write (13,4002) (tau(iask(j)), j=1,npt)

       do k=1,nsp
         i = iswap(k)
         iju = njlev(idsph2(1,i))
         if (mod(iju,2) .eq. 0) then
           poi = 2.0d0 * iju + 1.0
         else
           poi = (2.0d0 * iju + 1.0) * 3.0d0
         endif
         write(13,4001) nvlev(idsph2(1,i)), njlev(idsph2(1,i))
     1                , nvlev(idsph2(2,i)), njlev(idsph2(2,i))
     2                , spech2(0,i)
     2                , (spech2(j,i), j=1,npt)
       end do

c--------+---------+---------+---------+---------+---------+---------+-*-------+

 4002  format (1x,'v_up J_up v_low J_low lambda_mu ; t= ',
     1         1p,11(1x,e10.3))
 4001  format (1x,4(i4,1x),f10.6,1p,11(1x,e10.3))

       return
       end
